#include "matrix.h"
#include <cassert>
#include <chrono>
#include <ctime>
#include <iostream>
#include <vector>


int main()
{

//#####################################################################
    Performance_Test<double>();
    Performance_Test<float>();
    
    Performance_Test_Large<double>();
    Performance_Test_Large<float>();    
//#####################################################################

    return 0;
}

//https://de.wikipedia.org/wiki/Advanced_Vector_Extensions
//https://en.wikipedia.org/wiki/Advanced_Vector_Extensions

// Intel Core i7-7700 @ 8x 4.2GHz  (Kaby Lake)
//     16 DP FLOPs/cycle: two 4-wide FMA (fused multiply-add) instructions (https://stackoverflow.com/questions/15655835/flops-per-cycle-for-sandy-bridge-and-haswell-sse2-avx-avx2)
//     ==> 4 GHz * 16 ==> 64 GFLOPS/core
// http://www.cpu-world.com/CPUs/Core_i7/Intel-Core%20i7%20i7-7700.html
// https://ark.intel.com/content/www/de/de/ark/products/97128/intel-core-i7-7700-processor-8m-cache-up-to-4-20-ghz.html
// https://stackoverflow.com/questions/15655835/flops-per-cycle-for-sandy-bridge-and-haswell-sse2-avx-avx2

// GPU: NVIDIA GeForce GTX 1060 6 GB
// https://www.techpowerup.com/gpu-specs/geforce-gtx-1060-6-gb.c2862



//https://www.techpowerup.com/gpu-specs/geforce-gtx-1650.c3366
//https://de.wikipedia.org/wiki/Nvidia-GeForce-16-Serie#cite_note-6
//https://ark.intel.com/content/www/us/en/ark/products/196448/intel-core-i7-10710u-processor-12m-cache-up-to-4-70-ghz.html
